
// vcoauthDlg.cpp : t@C
//

#include "stdafx.h"
#include "vcoauth.h"
#include "vcoauthDlg.h"
#include "afxdialogex.h"

#include "nMail.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CvcoauthDlg _CAO
enum {
	serviceGmail,
	serviceOffice365,
};

const CString AuthUri[] = {
	_T("https://accounts.google.com/o/oauth2/auth"),
	_T("https://login.microsoftonline.com/%s/oauth2/v2.0/authorize")
};

const CString AuthScope[] = {
	_T("https://mail.google.com/"),
	_T("offline_access https://outlook.office.com/SMTP.Send https://outlook.office.com/POP.AccessAsUser.All https://outlook.office.com/IMAP.AccessAsUser.All")
};

const CString AuthParam[] = {
	_T("access_type=offline"),
	_T("")
};

const CString TokenUri[] = {
	_T("https://accounts.google.com/o/oauth2/token"),
	_T("https://login.microsoftonline.com/%s/oauth2/v2.0/token")
};

const CString SmtpHost[] = {
	_T("smtp.gmail.com"),
	_T("Smtp.office365.com"),
};

const CString Pop3Host[] = {
	_T("pop.gmail.com"),
	_T("Outlook.office365.com"),
};

const CString Imap4Host[] = {
	_T("imap.gmail.com"),
	_T("Outlook.office365.com"),
};

#define	TEMP_MAX		10000
#define	HEADER_MAX		8000
#define	BODY_MAX		100000
#define	STATE_LENGTH	16

const CString SectionSetting = _T("SETTING");
const CString KeyService = _T("SERVICE");
const CString KeyClientId = _T("CLIENT_ID");
const CString KeyClientSecret = _T("CLIENT_SECRET");
const CString KeyTenantId = _T("TENANT_ID");
const CString KeyRedirectUri = _T("REDIRECT_URI");
const CString SectionToken = _T("TOKEN");
const CString KeyRefresh = _T("REFRESH");
const CString KeyAccess = _T("ACCESS");
const CString SectionMail = _T("MAIL");
const CString KeyAddress = _T("ADDRESS");
const CString KeyType = _T("TYPE");

CvcoauthDlg::CvcoauthDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CvcoauthDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_service = serviceGmail;
	m_access_token = _T("");
	m_client_id = _T("");
	m_client_secret = _T("");
	m_redirect_uri = _T("");
	m_refresh_token = _T("");
	m_tenant_id = _T("");
	m_socket = INVALID_SOCKET;
	m_body = _T("");
	m_mail_address = _T("");
	m_mail_box = _T("INBOX");
	m_no = 1;
	m_subject = _T("");
	m_to = _T("");
}

void CvcoauthDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_GET_CODE, m_button_code);
	DDX_Control(pDX, IDC_BUTTON_GET_TOKEN, m_button_token);
	DDX_CBIndex(pDX, IDC_COMBO_SERVICE, m_service);
	DDX_Text(pDX, IDC_EDIT_ACCESS_TOKEN, m_access_token);
	DDX_Text(pDX, IDC_EDIT_CLIENT_ID, m_client_id);
	DDX_Text(pDX, IDC_EDIT_CLIENT_SECRET, m_client_secret);
	DDX_Text(pDX, IDC_EDIT_REDIRECT_URI, m_redirect_uri);
	DDX_Text(pDX, IDC_EDIT_REFRESH_TOKEN, m_refresh_token);
	DDX_Text(pDX, IDC_EDIT_TENANT_ID, m_tenant_id);
	DDX_Control(pDX, IDC_EDIT_TENANT_ID, m_edit_tenant_id);
	DDX_Control(pDX, IDC_STATIC_TENANT_ID, m_static_tenant_id);
	DDX_Control(pDX, IDC_EDIT_REFRESH_TOKEN, m_edit_refresh_token);
	DDX_Control(pDX, IDC_EDIT_ACCESS_TOKEN, m_edit_access_token);
	DDX_Control(pDX, IDC_STATIC_AUTH_URI, m_static_auth_uri);
	DDX_Control(pDX, IDC_STATIC_TOKEN_URI, m_static_token_uri);
	DDX_Control(pDX, IDC_BUTTON_RECEIVE, m_button_receive);
	DDX_Control(pDX, IDC_BUTTON_SEND, m_button_send);
	DDX_Text(pDX, IDC_EDIT_BODY, m_body);
	DDX_Text(pDX, IDC_EDIT_MAIL_ADDRESS, m_mail_address);
	DDX_Text(pDX, IDC_EDIT_MAIL_BOX, m_mail_box);
	DDX_Text(pDX, IDC_EDIT_NO, m_no);
	DDV_MinMaxInt(pDX, m_no, 1, 100);
	DDX_Text(pDX, IDC_EDIT_SUBJECT, m_subject);
	DDX_Text(pDX, IDC_EDIT_TO, m_to);
	DDX_Control(pDX, IDC_EDIT_BODY, m_edit_body);
	DDX_Control(pDX, IDC_SPIN_NO, m_spin_no);
}

BEGIN_MESSAGE_MAP(CvcoauthDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_GET_CODE, &CvcoauthDlg::OnBnClickedButtonGetCode)
	ON_BN_CLICKED(IDC_BUTTON_GET_TOKEN, &CvcoauthDlg::OnBnClickedButtonGetToken)
	ON_MESSAGE(WM_GET_CODE, &CvcoauthDlg::OnGetCode)
	ON_CBN_SELCHANGE(IDC_COMBO_SERVICE, &CvcoauthDlg::OnSelchangeComboService)
	ON_EN_UPDATE(IDC_EDIT_TENANT_ID, &CvcoauthDlg::OnUpdateEditTenantId)
	ON_BN_CLICKED(IDC_BUTTON_RECEIVE, &CvcoauthDlg::OnBnClickedButtonReceive)
	ON_BN_CLICKED(IDC_BUTTON_SEND, &CvcoauthDlg::OnBnClickedButtonSend)
	ON_BN_CLICKED(IDC_BUTTON_RECEIVE_IMAP4, &CvcoauthDlg::OnBnClickedButtonReceiveImap4)
END_MESSAGE_MAP()


// CvcoauthDlg bZ[W nh[

BOOL CvcoauthDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

    // Winsock 
    NMailInitializeWinSock();

	NMailSetOption(NMAIL_OPTION_HEADER_MAX, HEADER_MAX);
	NMailSetOption(NMAIL_OPTION_BODY_MAX, BODY_MAX);

	CString dir;
	::GetCurrentDirectory(MAX_PATH, dir.GetBuffer(MAX_PATH));
	dir.ReleaseBuffer();
	m_ini_file = dir + _T("\\vcoauth.ini");
	ReadIni();

	m_spin_no.SetRange32(1, 100);
	m_spin_no.SetPos32(1);

	CheckEnableControl();

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CvcoauthDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CvcoauthDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CvcoauthDlg::OnBnClickedButtonGetCode()
{
	UpdateData(TRUE);

	if(m_socket == INVALID_SOCKET) {
		m_refresh_token.Empty();
		m_access_token.Empty();
		UpdateData(FALSE);
		if((m_socket = NMailOAuth2StartRedirectServer(m_redirect_uri, GetString(IDS_RESPONSE_OK), GetString(IDS_RESPONSE_ERROR), m_hWnd, WM_GET_CODE, 0)) != INVALID_SOCKET) {
			NMailMakeRandomString(m_state.GetBuffer(STATE_LENGTH + 1), STATE_LENGTH, 0);
			m_state.ReleaseBuffer();
			if(NMailOAuth2RequestAuthorize(GetAuthUri(), m_client_id, m_redirect_uri, AuthScope[m_service], m_state, NULL, AuthParam[m_service], 0) != NMAIL_SUCCESS) {
				AfxMessageBox(GetString(IDS_ERROR_REFRESH_TOKEN));
				NMailOAuth2EndRedirectServer(m_socket);
				m_socket = INVALID_SOCKET;
			}
		} else {
			AfxMessageBox(GetString(IDS_ERROR_REDIRECT_SERVER));
		}
	} else {
		NMailOAuth2EndRedirectServer(m_socket);
		m_socket = INVALID_SOCKET;
	}
	CheckEnableControl();
}


void CvcoauthDlg::OnBnClickedButtonGetToken()
{
	int result;
	CString json;

	UpdateData(TRUE);

	// tbVg[NgăANZXg[N擾
	result = NMailOAuth2GetAccessToken(GetTokenUri(), m_client_id, m_client_secret, m_refresh_token, NULL, NULL, json.GetBuffer(TEMP_MAX), TEMP_MAX, 0);
	json.ReleaseBuffer();
	if(result == NMAIL_SUCCESS) {
		result = NMailJsonGetValue(json, _T("access_token"), m_access_token.GetBuffer(TEMP_MAX), TEMP_MAX, 0);
		m_access_token.ReleaseBuffer();
	}
	UpdateData(FALSE);
	if(result == NMAIL_SUCCESS) {
		m_edit_access_token.SetSel(0, -1);
		m_edit_access_token.Copy();
		m_edit_access_token.SetSel(0, 0);
	} else {
		AfxMessageBox(GetString(IDS_ERROR_ACCESS_TOKEN));
	}
}

LRESULT CvcoauthDlg::OnGetCode(WPARAM wParam, LPARAM lParam)
{
	CString code, state;
	int result;

	// FR[hƃXe[g擾
	result = NMailOAuth2GetAuthorizeCode(m_socket, code.GetBuffer(TEMP_MAX), TEMP_MAX, state.GetBuffer(TEMP_MAX), TEMP_MAX);
	code.ReleaseBuffer();
	state.ReleaseBuffer();
	// _CNgT[o[I
	NMailOAuth2EndRedirectServer(m_socket);
	m_socket = INVALID_SOCKET;
	if(result != NMAIL_SUCCESS) {
		AfxMessageBox(GetString(IDS_ERROR_REFRESH_TOKEN) + _T("\r\n") + code + state);
	} else if(state != m_state) {
		// CSRF ΍
		AfxMessageBox(GetString(IDS_ERROR_STATE_STRING));
	} else {
		// 擾FR[hgătbVg[N擾
		CString json;
		result = NMailOAuth2GetRefreshToken(GetTokenUri(), m_client_id, m_client_secret, m_redirect_uri, code, NULL, NULL, NULL, json.GetBuffer(TEMP_MAX), TEMP_MAX, 0);
		json.ReleaseBuffer();
		if(result == NMAIL_SUCCESS) {
			result = NMailJsonGetValue(json, _T("refresh_token"), m_refresh_token.GetBuffer(TEMP_MAX), TEMP_MAX, 0);
			m_refresh_token.ReleaseBuffer();
			NMailJsonGetValue(json, _T("access_token"), m_access_token.GetBuffer(TEMP_MAX), TEMP_MAX, 0);
			m_access_token.ReleaseBuffer();
		}
		UpdateData(FALSE);
		if(result == NMAIL_SUCCESS) {
			m_edit_refresh_token.SetSel(0, -1);
			m_edit_refresh_token.Copy();
			m_edit_refresh_token.SetSel(0, 0);

			WriteIni();
		} else {
			if(result == NMAIL_ERROR_JSON_NO_VALUE) {
				AfxMessageBox(GetString(IDS_ERROR_LOGOUT_REFRESH_TOKEN));
			} else {
				AfxMessageBox(GetString(IDS_ERROR_REFRESH_TOKEN));
			}
		}
	}
	CheckEnableControl();

	return FALSE;
}


BOOL CvcoauthDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_KEYDOWN) {
		if(pMsg->wParam == VK_RETURN) {
			CWnd *wnd = GetFocus();
			if(wnd != &m_edit_body) {
				return TRUE;
			}
		} else if(pMsg->wParam == VK_ESCAPE) {
			return TRUE;
		}
	}
	return CDialogEx::PreTranslateMessage(pMsg);
}

void CvcoauthDlg::CheckEnableControl()
{
	UpdateData(TRUE);
	m_edit_tenant_id.EnableWindow(m_service == serviceOffice365);
	m_static_tenant_id.EnableWindow(m_service == serviceOffice365);
	if(m_socket == INVALID_SOCKET) {
		m_button_code.SetWindowText(GetString(IDS_BUTTON_START));
		m_button_token.EnableWindow(!m_refresh_token.IsEmpty());
	} else {
		m_button_code.SetWindowText(GetString(IDS_BUTTON_STOP));
		m_button_token.EnableWindow(FALSE);
	}
	m_static_auth_uri.SetWindowText(GetAuthUri());
	m_static_token_uri.SetWindowText(GetTokenUri());
}

void CvcoauthDlg::ReadIni()
{
	m_service = ::GetPrivateProfileInt(SectionSetting, KeyService, serviceGmail, m_ini_file);
	::GetPrivateProfileString(SectionSetting, KeyClientId, _T(""), m_client_id.GetBuffer(TEMP_MAX), TEMP_MAX, m_ini_file);
	m_client_id.ReleaseBuffer();
	::GetPrivateProfileString(SectionSetting, KeyClientSecret, _T(""), m_client_secret.GetBuffer(TEMP_MAX), TEMP_MAX, m_ini_file);
	m_client_secret.ReleaseBuffer();
	::GetPrivateProfileString(SectionSetting, KeyTenantId, _T(""), m_tenant_id.GetBuffer(TEMP_MAX), TEMP_MAX, m_ini_file);
	m_tenant_id.ReleaseBuffer();
	::GetPrivateProfileString(SectionSetting, KeyRedirectUri, _T(""), m_redirect_uri.GetBuffer(TEMP_MAX), TEMP_MAX, m_ini_file);
	m_redirect_uri.ReleaseBuffer();
	::GetPrivateProfileString(SectionToken, KeyRefresh, _T(""), m_refresh_token.GetBuffer(TEMP_MAX), TEMP_MAX, m_ini_file);
	m_refresh_token.ReleaseBuffer();
	::GetPrivateProfileString(SectionToken, KeyAccess, _T(""), m_access_token.GetBuffer(TEMP_MAX), TEMP_MAX, m_ini_file);
	m_access_token.ReleaseBuffer();
	::GetPrivateProfileString(SectionMail, KeyAddress, _T(""), m_mail_address.GetBuffer(TEMP_MAX), TEMP_MAX, m_ini_file);
	m_mail_address.ReleaseBuffer();

	UpdateData(FALSE);
}

void CvcoauthDlg::WriteIni()
{
	CString str;

	str.Format(_T("%d"), m_service);
	::WritePrivateProfileString(SectionSetting, KeyService, str, m_ini_file);
	::WritePrivateProfileString(SectionSetting, KeyClientId, m_client_id, m_ini_file);
	::WritePrivateProfileString(SectionSetting, KeyClientSecret, m_client_secret, m_ini_file);
	::WritePrivateProfileString(SectionSetting, KeyTenantId, m_tenant_id, m_ini_file);
	::WritePrivateProfileString(SectionSetting, KeyRedirectUri, m_redirect_uri, m_ini_file);
	::WritePrivateProfileString(SectionToken, KeyRefresh, m_refresh_token, m_ini_file);
	::WritePrivateProfileString(SectionToken, KeyAccess, m_access_token, m_ini_file);
	::WritePrivateProfileString(SectionMail, KeyAddress, m_mail_address, m_ini_file);
}

CString CvcoauthDlg::GetString(int id)
{
	CString str;
	str.LoadString(id);
	return str;
}

CString CvcoauthDlg::GetTokenUri()
{
	CString uri;
	if(m_service == serviceOffice365) {
		uri.Format(TokenUri[m_service], m_tenant_id);
	} else {
		uri = TokenUri[m_service];
	}
	return uri;
}

CString CvcoauthDlg::GetAuthUri()
{
	CString uri;
	if(m_service == serviceOffice365) {
		uri.Format(AuthUri[m_service], m_tenant_id);
	} else {
		uri = AuthUri[m_service];
	}
	return uri;
}

BOOL CvcoauthDlg::DestroyWindow()
{
	UpdateData(TRUE);
	WriteIni();

	NMailEndWinSock();

	return CDialogEx::DestroyWindow();
}


void CvcoauthDlg::OnSelchangeComboService()
{
	UpdateData(TRUE);
	CheckEnableControl();
}


void CvcoauthDlg::OnUpdateEditTenantId()
{
	UpdateData(TRUE);
	CheckEnableControl();
}


void CvcoauthDlg::OnBnClickedButtonReceive()
{
	UpdateData(TRUE);
	if(m_mail_address.IsEmpty()) {
		AfxMessageBox(GetString(IDS_ERROR_NO_MAIL_ADDRESS));
		return;
	}
	if(m_access_token.IsEmpty()) {
		AfxMessageBox(GetString(IDS_ERROR_NO_ACCESS_TOKEN));
		return;
	}

	if(AfxMessageBox(GetString(IDS_WANT_TO_RECEIVE), MB_YESNO) == IDYES) {
		TCHAR header[HEADER_MAX], subject[HEADER_MAX], date[HEADER_MAX], from[HEADER_MAX];
		TCHAR body[BODY_MAX];
		SOCKET s;
		if((s = NMailPop3ConnectSsl(Pop3Host[m_service], NMAIL_POP3_SSL_PORT, NMAIL_SSL_TLS1, NULL)) != INVALID_SOCKET) {
			bool error_flag = true;
			int no;
			if((no = NMailPop3AuthenticateMode(s, m_mail_address, m_access_token, NMAIL_POP3_AUTH_OAUTH2)) >= 0) {
				if(m_no <= no) {
					if(NMailPop3GetMail(s, m_no, subject, date, from, header, body, NULL, NULL) == NMAIL_SUCCESS) {
						m_subject = subject;
						m_body = body;
						m_to = from;
						m_to_received = m_to;
						m_subject_received = m_subject;
						UpdateData(FALSE);
						error_flag = false;
					}
				} else {
					AfxMessageBox(GetString(IDS_ERROR_NO_MAIL_NO));
					error_flag = false;
				}
			}
			if(error_flag) {
				NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, header, HEADER_MAX);
				AfxMessageBox(header);
			}
			NMailPop3Close(s);
		} else {
			AfxMessageBox(GetString(IDS_ERROR_CONNECT));
		}
	}
}


void CvcoauthDlg::OnBnClickedButtonSend()
{
	UpdateData(TRUE);
	if(m_mail_address.IsEmpty()) {
		AfxMessageBox(GetString(IDS_ERROR_NO_MAIL_ADDRESS));
		return;
	}
	if(m_access_token.IsEmpty()) {
		AfxMessageBox(GetString(IDS_ERROR_NO_ACCESS_TOKEN));
		return;
	}
	if(m_to.IsEmpty()) {
		AfxMessageBox(GetString(IDS_ERROR_NO_TO));
		return;
	}
	if(m_subject.IsEmpty()) {
		AfxMessageBox(GetString(IDS_ERROR_NO_SUBJECT));
		return;
	}
	if(m_to == m_to_received && m_subject == m_subject_received) {
		AfxMessageBox(GetString(IDS_ERROR_SAME_MAIL));
		return;
	}
	if(AfxMessageBox(GetString(IDS_WANT_TO_SEND), MB_YESNO) == IDYES) {
		SOCKET s;
		int port = NMAIL_SMTP_SSL_PORT;
		int ssl_mode = NMAIL_SSL_TLS1;
		if(m_service == serviceOffice365) {
			port = NMAIL_SMTP_SUBMISSION_PORT;
			ssl_mode |= NMAIL_SSL_STARTTLS;
		}
		if((s = NMailSmtpConnectSsl(SmtpHost[m_service], port, ssl_mode, NULL)) != INVALID_SOCKET) {
			bool error_flag = true;
			if(NMailSmtpAuthenticate(s, SmtpHost[m_service], m_mail_address, m_access_token, NMAIL_SMTP_AUTH_OAUTH2) == NMAIL_SUCCESS) {
				if(NMailSmtpSendMailEx(s, m_to, NULL, NULL, m_mail_address, m_subject, m_body, NULL, NULL, NULL, 0) == NMAIL_SUCCESS) {
					AfxMessageBox(GetString(IDS_SEND_SUCCESS));
					error_flag = false;
				}
			}
			if(error_flag) {
				TCHAR msg[HEADER_MAX];
				NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, msg, HEADER_MAX);
				AfxMessageBox(msg);
			}
		} else {
			AfxMessageBox(GetString(IDS_ERROR_CONNECT));
		}
	}
}


void CvcoauthDlg::OnBnClickedButtonReceiveImap4()
{
	UpdateData(TRUE);
	if(m_mail_address.IsEmpty()) {
		AfxMessageBox(GetString(IDS_ERROR_NO_MAIL_ADDRESS));
		return;
	}
	if(m_access_token.IsEmpty()) {
		AfxMessageBox(GetString(IDS_ERROR_NO_ACCESS_TOKEN));
		return;
	}

	if(AfxMessageBox(GetString(IDS_WANT_TO_RECEIVE), MB_YESNO) == IDYES) {
		TCHAR header[HEADER_MAX], subject[HEADER_MAX], date[HEADER_MAX], from[HEADER_MAX];
		TCHAR body[BODY_MAX];
		SOCKET s;
		if((s = NMailImap4ConnectSsl(Imap4Host[m_service], NMAIL_IMAP4_SSL_PORT, NMAIL_SSL_TLS1, NULL)) != INVALID_SOCKET) {
			bool error_flag = true;
			if(NMailImap4Authenticate(s, m_mail_address, m_access_token, NMAIL_IMAP4_AUTH_OAUTH2) == NMAIL_SUCCESS) {
				if(NMailImap4SelectMailBox(s, m_mail_box, FALSE) >= 0) {
					int count;
					if((count = NMailImap4SearchMail(s, NMAIL_IMAP4_SEARCH_UNDELETED, NULL, NMAIL_IMAP4_USE_UID)) > 0) {
						if(m_no <= count) {
							DWORD uid;
							NMailImap4GetSearchMailResult(s, m_no - 1, &uid);
							if(NMailImap4GetMail(s, uid, subject, date, from, header, body, NULL, NULL, NMAIL_IMAP4_USE_UID) == NMAIL_SUCCESS) {
								m_subject = subject;
								m_body = body;
								m_to = from;
								m_to_received = m_to;
								m_subject_received = m_subject;
								UpdateData(FALSE);
								error_flag = false;
							}
						} else {
							AfxMessageBox(GetString(IDS_ERROR_NO_MAIL_NO));
							error_flag = false;
						}
					}
				}
			}
			if(error_flag) {
				NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, header, HEADER_MAX);
				AfxMessageBox(header);
			}
			NMailImap4Close(s);
		} else {
			AfxMessageBox(GetString(IDS_ERROR_CONNECT));
		}
	}
}
